import React__default, { createContext, useContext, useEffect, forwardRef, createElement, Component } from 'react';
import 'antd/dist/antd.css';
import { Form, Card, List, Button, Row, Col, Input, Checkbox, Divider, AutoComplete as AutoComplete$2, Select as Select$1, Radio, InputNumber, DatePicker, Switch, Tooltip } from 'antd';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var styles = {"item":"_VrCvP","actions":"_3eZoM","test":"_3ybTi"};

var IconContext = /*#__PURE__*/createContext({});

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray$1(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _unsupportedIterableToArray$1(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray$1(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest();
}

function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose$1(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classnames = createCommonjsModule(function (module) {
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {

	var hasOwn = {}.hasOwnProperty;

	function classNames() {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg)) {
				if (arg.length) {
					var inner = classNames.apply(null, arg);
					if (inner) {
						classes.push(inner);
					}
				}
			} else if (argType === 'object') {
				if (arg.toString === Object.prototype.toString) {
					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				} else {
					classes.push(arg.toString());
				}
			}
		}

		return classes.join(' ');
	}

	if ( module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

/**
 * Take input from [0, n] and return it as [0, 1]
 * @hidden
 */
function bound01(n, max) {
    if (isOnePointZero(n)) {
        n = '100%';
    }
    var isPercent = isPercentage(n);
    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
    // Automatically convert percentage into number
    if (isPercent) {
        n = parseInt(String(n * max), 10) / 100;
    }
    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
        return 1;
    }
    // Convert into [0, 1] range if it isn't already
    if (max === 360) {
        // If n is a hue given in degrees,
        // wrap around out-of-range values into [0, 360] range
        // then convert into [0, 1].
        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
    }
    else {
        // If n not a hue given in degrees
        // Convert into [0, 1] range if it isn't already.
        n = (n % max) / parseFloat(String(max));
    }
    return n;
}
/**
 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
 * @hidden
 */
function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
}
/**
 * Check to see if string passed in is a percentage
 * @hidden
 */
function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') !== -1;
}
/**
 * Return a valid alpha value [0,1] with all invalid values being set to 1
 * @hidden
 */
function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }
    return a;
}
/**
 * Replace a decimal with it's percentage value
 * @hidden
 */
function convertToPercentage(n) {
    if (n <= 1) {
        return Number(n) * 100 + "%";
    }
    return n;
}
/**
 * Force a hex value to have 2 characters
 * @hidden
 */
function pad2(c) {
    return c.length === 1 ? '0' + c : String(c);
}

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
/**
 * Handle bounds / percentage checking to conform to CSS color spec
 * <http://www.w3.org/TR/css3-color/>
 * *Assumes:* r, g, b in [0, 255] or [0, 1]
 * *Returns:* { r, g, b } in [0, 255]
 */
function rgbToRgb(r, g, b) {
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255,
    };
}
function hue2rgb(p, q, t) {
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * (6 * t);
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
}
/**
 * Converts an HSL color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hslToRgb(h, s, l) {
    var r;
    var g;
    var b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    if (s === 0) {
        // achromatic
        g = l;
        b = l;
        r = l;
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color value to HSV
 *
 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
 * *Returns:* { h, s, v } in [0,1]
 */
function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var v = max;
    var d = max - min;
    var s = max === 0 ? 0 : d / max;
    if (max === min) {
        h = 0; // achromatic
    }
    else {
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}
/**
 * Converts an HSV color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h);
    var f = h - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);
    var mod = i % 6;
    var r = [v, q, p, p, t, v][mod];
    var g = [t, v, v, q, p, p][mod];
    var b = [p, p, t, v, v, q][mod];
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color to hex
 *
 * Assumes r, g, and b are contained in the set [0, 255]
 * Returns a 3 or 6 character hex
 */
function rgbToHex(r, g, b, allow3Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    // Return a 3 character hex if possible
    if (allow3Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join('');
}
/** Converts a hex value to a decimal */
function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
}
/** Parse a base-16 hex value into a base-10 integer */
function parseIntFromHex(val) {
    return parseInt(val, 16);
}

// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
/**
 * @hidden
 */
var names = {
    aliceblue: '#f0f8ff',
    antiquewhite: '#faebd7',
    aqua: '#00ffff',
    aquamarine: '#7fffd4',
    azure: '#f0ffff',
    beige: '#f5f5dc',
    bisque: '#ffe4c4',
    black: '#000000',
    blanchedalmond: '#ffebcd',
    blue: '#0000ff',
    blueviolet: '#8a2be2',
    brown: '#a52a2a',
    burlywood: '#deb887',
    cadetblue: '#5f9ea0',
    chartreuse: '#7fff00',
    chocolate: '#d2691e',
    coral: '#ff7f50',
    cornflowerblue: '#6495ed',
    cornsilk: '#fff8dc',
    crimson: '#dc143c',
    cyan: '#00ffff',
    darkblue: '#00008b',
    darkcyan: '#008b8b',
    darkgoldenrod: '#b8860b',
    darkgray: '#a9a9a9',
    darkgreen: '#006400',
    darkgrey: '#a9a9a9',
    darkkhaki: '#bdb76b',
    darkmagenta: '#8b008b',
    darkolivegreen: '#556b2f',
    darkorange: '#ff8c00',
    darkorchid: '#9932cc',
    darkred: '#8b0000',
    darksalmon: '#e9967a',
    darkseagreen: '#8fbc8f',
    darkslateblue: '#483d8b',
    darkslategray: '#2f4f4f',
    darkslategrey: '#2f4f4f',
    darkturquoise: '#00ced1',
    darkviolet: '#9400d3',
    deeppink: '#ff1493',
    deepskyblue: '#00bfff',
    dimgray: '#696969',
    dimgrey: '#696969',
    dodgerblue: '#1e90ff',
    firebrick: '#b22222',
    floralwhite: '#fffaf0',
    forestgreen: '#228b22',
    fuchsia: '#ff00ff',
    gainsboro: '#dcdcdc',
    ghostwhite: '#f8f8ff',
    goldenrod: '#daa520',
    gold: '#ffd700',
    gray: '#808080',
    green: '#008000',
    greenyellow: '#adff2f',
    grey: '#808080',
    honeydew: '#f0fff0',
    hotpink: '#ff69b4',
    indianred: '#cd5c5c',
    indigo: '#4b0082',
    ivory: '#fffff0',
    khaki: '#f0e68c',
    lavenderblush: '#fff0f5',
    lavender: '#e6e6fa',
    lawngreen: '#7cfc00',
    lemonchiffon: '#fffacd',
    lightblue: '#add8e6',
    lightcoral: '#f08080',
    lightcyan: '#e0ffff',
    lightgoldenrodyellow: '#fafad2',
    lightgray: '#d3d3d3',
    lightgreen: '#90ee90',
    lightgrey: '#d3d3d3',
    lightpink: '#ffb6c1',
    lightsalmon: '#ffa07a',
    lightseagreen: '#20b2aa',
    lightskyblue: '#87cefa',
    lightslategray: '#778899',
    lightslategrey: '#778899',
    lightsteelblue: '#b0c4de',
    lightyellow: '#ffffe0',
    lime: '#00ff00',
    limegreen: '#32cd32',
    linen: '#faf0e6',
    magenta: '#ff00ff',
    maroon: '#800000',
    mediumaquamarine: '#66cdaa',
    mediumblue: '#0000cd',
    mediumorchid: '#ba55d3',
    mediumpurple: '#9370db',
    mediumseagreen: '#3cb371',
    mediumslateblue: '#7b68ee',
    mediumspringgreen: '#00fa9a',
    mediumturquoise: '#48d1cc',
    mediumvioletred: '#c71585',
    midnightblue: '#191970',
    mintcream: '#f5fffa',
    mistyrose: '#ffe4e1',
    moccasin: '#ffe4b5',
    navajowhite: '#ffdead',
    navy: '#000080',
    oldlace: '#fdf5e6',
    olive: '#808000',
    olivedrab: '#6b8e23',
    orange: '#ffa500',
    orangered: '#ff4500',
    orchid: '#da70d6',
    palegoldenrod: '#eee8aa',
    palegreen: '#98fb98',
    paleturquoise: '#afeeee',
    palevioletred: '#db7093',
    papayawhip: '#ffefd5',
    peachpuff: '#ffdab9',
    peru: '#cd853f',
    pink: '#ffc0cb',
    plum: '#dda0dd',
    powderblue: '#b0e0e6',
    purple: '#800080',
    rebeccapurple: '#663399',
    red: '#ff0000',
    rosybrown: '#bc8f8f',
    royalblue: '#4169e1',
    saddlebrown: '#8b4513',
    salmon: '#fa8072',
    sandybrown: '#f4a460',
    seagreen: '#2e8b57',
    seashell: '#fff5ee',
    sienna: '#a0522d',
    silver: '#c0c0c0',
    skyblue: '#87ceeb',
    slateblue: '#6a5acd',
    slategray: '#708090',
    slategrey: '#708090',
    snow: '#fffafa',
    springgreen: '#00ff7f',
    steelblue: '#4682b4',
    tan: '#d2b48c',
    teal: '#008080',
    thistle: '#d8bfd8',
    tomato: '#ff6347',
    turquoise: '#40e0d0',
    violet: '#ee82ee',
    wheat: '#f5deb3',
    white: '#ffffff',
    whitesmoke: '#f5f5f5',
    yellow: '#ffff00',
    yellowgreen: '#9acd32',
};

/**
 * Given a string or object, convert that input to RGB
 *
 * Possible string inputs:
 * ```
 * "red"
 * "#f00" or "f00"
 * "#ff0000" or "ff0000"
 * "#ff000000" or "ff000000"
 * "rgb 255 0 0" or "rgb (255, 0, 0)"
 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
 * ```
 */
function inputToRGB(color) {
    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color === 'string') {
        color = stringInputToObject(color);
    }
    if (typeof color === 'object') {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = 'hsv';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = 'hsl';
        }
        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
            a = color.a;
        }
    }
    a = boundAlpha(a);
    return {
        ok: ok,
        format: color.format || format,
        r: Math.min(255, Math.max(rgb.r, 0)),
        g: Math.min(255, Math.max(rgb.g, 0)),
        b: Math.min(255, Math.max(rgb.b, 0)),
        a: a,
    };
}
// <http://www.w3.org/TR/css3-values/#integers>
var CSS_INTEGER = '[-\\+]?\\d+%?';
// <http://www.w3.org/TR/css3-values/#number-value>
var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
// Actual matching.
// Parentheses and commas are optional, but not required.
// Whitespace can take the place of commas or opening paren
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
    CSS_UNIT: new RegExp(CSS_UNIT),
    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
};
/**
 * Permissive string parsing.  Take in a number of formats, and output an object
 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
 */
function stringInputToObject(color) {
    color = color.trim().toLowerCase();
    if (color.length === 0) {
        return false;
    }
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color === 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
    }
    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match = matchers.rgb.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    match = matchers.hsv.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    match = matchers.hsva.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex6.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            a: convertHexToDecimal(match[4] + match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    return false;
}
/**
 * Check to see if it looks like a CSS unit
 * (see `matchers` above for definition).
 */
function isValidCSSUnit(color) {
    return Boolean(matchers.CSS_UNIT.exec(String(color)));
}

var hueStep = 2; // 色相阶梯

var saturationStep = 0.16; // 饱和度阶梯，浅色部分

var saturationStep2 = 0.05; // 饱和度阶梯，深色部分

var brightnessStep1 = 0.05; // 亮度阶梯，浅色部分

var brightnessStep2 = 0.15; // 亮度阶梯，深色部分

var lightColorCount = 5; // 浅色数量，主色上

var darkColorCount = 4; // 深色数量，主色下
// 暗色主题颜色映射关系表

var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}]; // Wrapper function ported from TinyColor.prototype.toHsv
// Keep it here because of `hsv.h * 360`

function toHsv(_ref) {
  var r = _ref.r,
      g = _ref.g,
      b = _ref.b;
  var hsv = rgbToHsv(r, g, b);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
} // Wrapper function ported from TinyColor.prototype.toHexString
// Keep it here because of the prefix `#`


function toHex(_ref2) {
  var r = _ref2.r,
      g = _ref2.g,
      b = _ref2.b;
  return "#".concat(rgbToHex(r, g, b, false));
} // Wrapper function ported from TinyColor.prototype.mix, not treeshakable.
// Amount in range [0, 1]
// Assume color1 & color2 has no alpha, since the following src code did so.


function mix(rgb1, rgb2, amount) {
  var p = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p + rgb1.r,
    g: (rgb2.g - rgb1.g) * p + rgb1.g,
    b: (rgb2.b - rgb1.b) * p + rgb1.b
  };
  return rgb;
}

function getHue(hsv, i, light) {
  var hue; // 根据色相不同，色相转向不同

  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }

  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }

  return hue;
}

function getSaturation(hsv, i, light) {
  // grey color don't change saturation
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }

  var saturation;

  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  } // 边界值修正


  if (saturation > 1) {
    saturation = 1;
  } // 第一格的 s 限制在 0.06-0.1 之间


  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }

  if (saturation < 0.06) {
    saturation = 0.06;
  }

  return Number(saturation.toFixed(2));
}

function getValue(hsv, i, light) {
  var value;

  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }

  if (value > 1) {
    value = 1;
  }

  return Number(value.toFixed(2));
}

function generate(color) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);

  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue(hsv, i, true)
    }));
    patterns.push(colorString);
  }

  patterns.push(toHex(pColor));

  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);

    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue(_hsv, _i)
    }));

    patterns.push(_colorString);
  } // dark theme patterns


  if (opts.theme === 'dark') {
    return darkColorMap.map(function (_ref3) {
      var index = _ref3.index,
          opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || '#141414'), inputToRGB(patterns[index]), opacity * 100));
      return darkColorString;
    });
  }

  return patterns;
}

var presetPrimaryColors = {
  red: '#F5222D',
  volcano: '#FA541C',
  orange: '#FA8C16',
  gold: '#FAAD14',
  yellow: '#FADB14',
  lime: '#A0D911',
  green: '#52C41A',
  cyan: '#13C2C2',
  blue: '#1890FF',
  geekblue: '#2F54EB',
  purple: '#722ED1',
  magenta: '#EB2F96',
  grey: '#666666'
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function (key) {
  presetPalettes[key] = generate(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5]; // dark presetPalettes

  presetDarkPalettes[key] = generate(presetPrimaryColors[key], {
    theme: 'dark',
    backgroundColor: '#141414'
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});

/* eslint-disable no-console */
var warned = {};
function warning(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    console.error("Warning: ".concat(message));
  }
}
function call(method, valid, message) {
  if (!valid && !warned[message]) {
    method(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning, valid, message);
}
/* eslint-enable */

function canUseDom() {
  return !!(typeof window !== 'undefined' && window.document && window.document.createElement);
}

var MARK_KEY = "rc-util-key";

function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      mark = _ref.mark;

  if (mark) {
    return mark.startsWith('data-') ? mark : "data-".concat(mark);
  }

  return MARK_KEY;
}

function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }

  var head = document.querySelector('head');
  return head || document.body;
}

function injectCSS(css) {
  var _option$csp;

  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!canUseDom()) {
    return null;
  }

  var styleNode = document.createElement('style');

  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;

    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }

  styleNode.innerHTML = css;
  var container = getContainer(option);
  var firstChild = container.firstChild;

  if (option.prepend && container.prepend) {
    // Use `prepend` first
    container.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    // Fallback to `insertBefore` like IE not support `prepend`
    container.insertBefore(styleNode, firstChild);
  } else {
    container.appendChild(styleNode);
  }

  return styleNode;
}
var containerCache = new Map();

function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var container = getContainer(option);
  return Array.from(containerCache.get(container).children).find(function (node) {
    return node.tagName === 'STYLE' && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var container = getContainer(option); // Get real parent

  if (!containerCache.has(container)) {
    var placeholderStyle = injectCSS('', option);
    var parentNode = placeholderStyle.parentNode;
    containerCache.set(container, parentNode);
    parentNode.removeChild(placeholderStyle);
  }

  var existNode = findExistNode(key, option);

  if (existNode) {
    var _option$csp3, _option$csp4;

    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;

      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }

    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }

    return existNode;
  }

  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}

function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && (_typeof(target.icon) === 'object' || typeof target.icon === 'function');
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attrs).reduce(function (acc, key) {
    var val = attrs[key];

    switch (key) {
      case 'class':
        acc.className = val;
        delete acc.class;
        break;

      default:
        acc[key] = val;
    }

    return acc;
  }, {});
}
function generate$1(node, key, rootProps) {
  if (!rootProps) {
    return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2({
      key: key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
      return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }

  return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key: key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
    return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
  }));
}
function getSecondaryColor(primaryColor) {
  // choose the second color
  return generate(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }

  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
} // These props make sure that the SVG behaviours like general text.
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles() {
  var styleStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : iconStyles;

  var _useContext = useContext(IconContext),
      csp = _useContext.csp;

  useEffect(function () {
    updateCSS(styleStr, '@ant-design-icons', {
      prepend: true,
      csp: csp
    });
  }, []);
};

var _excluded = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: '#333',
  secondaryColor: '#E6E6E6',
  calculated: false
};

function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor,
      secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}

function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}

var IconBase = function IconBase(props) {
  var icon = props.icon,
      className = props.className,
      onClick = props.onClick,
      style = props.style,
      primaryColor = props.primaryColor,
      secondaryColor = props.secondaryColor,
      restProps = _objectWithoutProperties(props, _excluded);

  var colors = twoToneColorPalette;

  if (primaryColor) {
    colors = {
      primaryColor: primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }

  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));

  if (!isIconDefinition(icon)) {
    return null;
  }

  var target = icon;

  if (target && typeof target.icon === 'function') {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }

  return generate$1(target.icon, "svg-".concat(target.name), _objectSpread2({
    className: className,
    onClick: onClick,
    style: style,
    'data-icon': target.name,
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true'
  }, restProps));
};

IconBase.displayName = 'IconReact';
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;

function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
      _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return IconBase.setTwoToneColors({
    primaryColor: primaryColor,
    secondaryColor: secondaryColor
  });
}
function getTwoToneColor() {
  var colors = IconBase.getTwoToneColors();

  if (!colors.calculated) {
    return colors.primaryColor;
  }

  return [colors.primaryColor, colors.secondaryColor];
}

var _excluded$1 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
// should move it to antd main repo?

setTwoToneColor('#1890ff');
var Icon = /*#__PURE__*/forwardRef(function (props, ref) {
  var _classNames;

  var className = props.className,
      icon = props.icon,
      spin = props.spin,
      rotate = props.rotate,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      twoToneColor = props.twoToneColor,
      restProps = _objectWithoutProperties(props, _excluded$1);

  var _React$useContext = useContext(IconContext),
      _React$useContext$pre = _React$useContext.prefixCls,
      prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre;

  var classString = classnames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === 'loading'), _classNames), className);
  var iconTabIndex = tabIndex;

  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }

  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;

  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
      _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return /*#__PURE__*/createElement("span", _objectSpread2(_objectSpread2({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), /*#__PURE__*/createElement(IconBase, {
    icon: icon,
    primaryColor: primaryColor,
    secondaryColor: secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = 'AntdIcon';
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;

// This icon file is generated automatically.
var CloseOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" } }] }, "name": "close", "theme": "outlined" };

var CloseOutlined$1 = function CloseOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref: ref,
    icon: CloseOutlined
  }));
};

CloseOutlined$1.displayName = 'CloseOutlined';
var CloseOutlined$2 = /*#__PURE__*/forwardRef(CloseOutlined$1);

// This icon file is generated automatically.
var CopyOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M832 64H296c-4.4 0-8 3.6-8 8v56c0 4.4 3.6 8 8 8h496v688c0 4.4 3.6 8 8 8h56c4.4 0 8-3.6 8-8V96c0-17.7-14.3-32-32-32zM704 192H192c-17.7 0-32 14.3-32 32v530.7c0 8.5 3.4 16.6 9.4 22.6l173.3 173.3c2.2 2.2 4.7 4 7.4 5.5v1.9h4.2c3.5 1.3 7.2 2 11 2H704c17.7 0 32-14.3 32-32V224c0-17.7-14.3-32-32-32zM350 856.2L263.9 770H350v86.2zM664 888H414V746c0-22.1-17.9-40-40-40H232V264h432v624z" } }] }, "name": "copy", "theme": "outlined" };

var CopyOutlined$1 = function CopyOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref: ref,
    icon: CopyOutlined
  }));
};

CopyOutlined$1.displayName = 'CopyOutlined';
var CopyOutlined$2 = /*#__PURE__*/forwardRef(CopyOutlined$1);

// This icon file is generated automatically.
var EditOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M257.7 752c2 0 4-.2 6-.5L431.9 722c2-.4 3.9-1.3 5.3-2.8l423.9-423.9a9.96 9.96 0 000-14.1L694.9 114.9c-1.9-1.9-4.4-2.9-7.1-2.9s-5.2 1-7.1 2.9L256.8 538.8c-1.5 1.5-2.4 3.3-2.8 5.3l-29.5 168.2a33.5 33.5 0 009.4 29.8c6.6 6.4 14.9 9.9 23.8 9.9zm67.4-174.4L687.8 215l73.3 73.3-362.7 362.6-88.9 15.7 15.6-89zM880 836H144c-17.7 0-32 14.3-32 32v36c0 4.4 3.6 8 8 8h784c4.4 0 8-3.6 8-8v-36c0-17.7-14.3-32-32-32z" } }] }, "name": "edit", "theme": "outlined" };

var EditOutlined$1 = function EditOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref: ref,
    icon: EditOutlined
  }));
};

EditOutlined$1.displayName = 'EditOutlined';
var EditOutlined$2 = /*#__PURE__*/forwardRef(EditOutlined$1);

// This icon file is generated automatically.
var PlusOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z" } }, { "tag": "path", "attrs": { "d": "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z" } }] }, "name": "plus", "theme": "outlined" };

var PlusOutlined$1 = function PlusOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref: ref,
    icon: PlusOutlined
  }));
};

PlusOutlined$1.displayName = 'PlusOutlined';
var PlusOutlined$2 = /*#__PURE__*/forwardRef(PlusOutlined$1);

var REQUIRED = 'required';
var LABEL = 'label';
var DESCRIPTION = 'description';
var TOGGLE = 'toggle';
var NAME = 'name';
var OPTIONS = 'values';
var PLACEHOLDER = 'placeholder';
var SUB_TYPE = 'subtype';
var CONTENT = 'content';
var ItemProperties = {
  REQUIRED: REQUIRED,
  LABEL: LABEL,
  DESCRIPTION: DESCRIPTION,
  PLACEHOLDER: PLACEHOLDER,
  TOGGLE: TOGGLE,
  NAME: NAME,
  OPTIONS: OPTIONS,
  SUB_TYPE: SUB_TYPE,
  CONTENT: CONTENT
};

var AUTOCOMPLETE = 'autocomplete';
var CHECK_BOX_GROUP = 'checkbox-group';
var BUTTON = 'button';
var DATE = 'date';
var HEADER = 'header';
var HIDDEN = 'hidden';
var NUMBER = 'number';
var PARAGRAPH = 'paragraph';
var RADIO_GROUP = 'radio-group';
var SELECT = 'select';
var TEXT = 'text';
var TEXT_AREA = 'textarea';
var ItemTypes = {
  AUTOCOMPLETE: AUTOCOMPLETE,
  CHECK_BOX_GROUP: CHECK_BOX_GROUP,
  BUTTON: BUTTON,
  DATE: DATE,
  HEADER: HEADER,
  HIDDEN: HIDDEN,
  NUMBER: NUMBER,
  PARAGRAPH: PARAGRAPH,
  RADIO_GROUP: RADIO_GROUP,
  SELECT: SELECT,
  TEXT: TEXT,
  TEXT_AREA: TEXT_AREA
};

var styles$1 = {"transition_height":"_33IkF","drag_button":"_20I08"};

var _excluded$2 = ["name", "isEditting", "onValuesChange", "initialValues", "edit"];

var AutoComplete = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(AutoComplete, _React$Component);

  function AutoComplete(props, label, type, properties) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _this.onValuesChange = function (changedValues, allValues) {
      if (_this.timeOut) {
        clearTimeout(_this.timeOut);
      }

      _this.timeOut = setTimeout(function () {
        if (_this.props.onValuesChange) _this.props.onValuesChange(_this.getValueChangeProps(allValues));
      }, 200);
    };

    _this.properties = properties;
    _this.label = label;
    _this.type = type;
    _this.state = _extends({}, Object.assign.apply(Object, [{}].concat(_this.properties.map(function (property) {
      var obj = {};

      if (property === ItemProperties.OPTIONS) {
        obj[property] = props.initialValues[property] ? props.initialValues[property].map(function (v) {
          return {
            label: v.label,
            value: v.value
          };
        }) : [{
          label: 'Option 1',
          value: 'option-1'
        }];
      } else if (property === ItemProperties.NAME) {
        obj[property] = _this.type + "-" + new Date().getTime();
      } else if (property === ItemProperties.LABEL) {
        obj[property] = props.initialValues[property] !== undefined ? props.initialValues[property] : _this.label;
      } else {
        obj[property] = props.initialValues[property];
      }

      return obj;
    }))));

    _this.startUpValuesChange();

    return _this;
  }

  var _proto = AutoComplete.prototype;

  _proto.startUpValuesChange = function startUpValuesChange() {
    if (this.props.onValuesChange) this.props.onValuesChange(this.getValueChangeProps(this.getInitialValues()));
  };

  _proto.getInitialValues = function getInitialValues() {
    var _this2 = this,
        _this$state$ItemPrope;

    return _extends({}, Object.assign.apply(Object, [{}].concat(this.properties.map(function (property) {
      var obj = {};
      obj[property] = _this2.state[property];
      return obj;
    }).concat((_this$state$ItemPrope = this.state[ItemProperties.OPTIONS]) === null || _this$state$ItemPrope === void 0 ? void 0 : _this$state$ItemPrope.map(function (option, index) {
      var _ref;

      return _ref = {}, _ref["option_label_" + index] = option.label, _ref["option_value_" + index] = option.value, _ref;
    })))));
  };

  _proto.getValueChangeProps = function getValueChangeProps(allValues) {
    var _this3 = this;

    return _extends({
      type: this.type
    }, Object.assign.apply(Object, [{}].concat(this.properties.map(function (property) {
      var obj = {};

      if (property === ItemProperties.OPTIONS) {
        obj[property] = _this3.state[property].map(function (option, index) {
          return {
            label: allValues["option_label_" + index],
            value: allValues["option_value_" + index]
          };
        });
      } else {
        obj[property] = allValues[property];
      }

      return obj;
    }))));
  };

  _proto.getProperty = function getProperty(property, index) {
    var _this4 = this;

    switch (property) {
      case ItemProperties.LABEL:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.LABEL,
          label: "Label"
        }, /*#__PURE__*/React__default.createElement(Input, {
          onChange: function onChange(e) {
            return _this4.setState({
              label: e.target.value
            });
          }
        }));

      case ItemProperties.NAME:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.NAME,
          label: "Name"
        }, /*#__PURE__*/React__default.createElement(Input, null));

      case ItemProperties.REQUIRED:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.REQUIRED,
          label: "Required",
          valuePropName: "checked"
        }, /*#__PURE__*/React__default.createElement(Checkbox, {
          onChange: function onChange(e) {
            return _this4.setState({
              required: e.target.checked
            });
          }
        }));

      case ItemProperties.TOGGLE:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.TOGGLE,
          label: "Toggle",
          valuePropName: "checked"
        }, /*#__PURE__*/React__default.createElement(Checkbox, {
          onChange: function onChange(e) {
            var _this4$setState;

            return _this4.setState((_this4$setState = {}, _this4$setState[ItemProperties.TOGGLE] = e.target.checked, _this4$setState));
          }
        }));

      case ItemProperties.PLACEHOLDER:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.PLACEHOLDER,
          label: "Placeholder"
        }, /*#__PURE__*/React__default.createElement(Input, {
          onChange: function onChange(e) {
            return _this4.setState({
              placeholder: e.target.value
            });
          }
        }));

      case ItemProperties.DESCRIPTION:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.DESCRIPTION,
          label: "Help Text"
        }, /*#__PURE__*/React__default.createElement(Input, {
          onChange: function onChange(e) {
            return _this4.setState({
              description: e.target.value
            });
          }
        }));

      case ItemProperties.OPTIONS:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          label: "Options"
        }, /*#__PURE__*/React__default.createElement(Card, null, /*#__PURE__*/React__default.createElement(List, {
          dataSource: this.state[ItemProperties.OPTIONS],
          footer: /*#__PURE__*/React__default.createElement(Button, {
            style: {
              margin: '8px 0'
            },
            size: "small",
            type: "link",
            icon: /*#__PURE__*/React__default.createElement(PlusOutlined$2, null),
            onClick: function onClick() {
              var _this4$setState2;

              var options = _this4.state[ItemProperties.OPTIONS];

              _this4.setState((_this4$setState2 = {}, _this4$setState2[ItemProperties.OPTIONS] = [].concat(options, [{
                label: '',
                value: ''
              }]), _this4$setState2));
            }
          }, "Add Option"),
          renderItem: function renderItem(item, index) {
            return /*#__PURE__*/React__default.createElement(List.Item, {
              key: index,
              extra: index !== 0 && /*#__PURE__*/React__default.createElement(Button, {
                icon: /*#__PURE__*/React__default.createElement(CloseOutlined$2, null),
                style: {
                  placeSelf: 'flex-start',
                  marginLeft: 8
                },
                onClick: function onClick() {
                  var _this4$setState3;

                  _this4.setState((_this4$setState3 = {}, _this4$setState3[ItemProperties.OPTIONS] = _this4.state[ItemProperties.OPTIONS].filter(function (item, i) {
                    return index !== i;
                  }), _this4$setState3));
                },
                size: "small",
                type: "link",
                danger: true,
                shape: "circle"
              })
            }, /*#__PURE__*/React__default.createElement(Row, {
              gutter: 16
            }, /*#__PURE__*/React__default.createElement(Col, null, /*#__PURE__*/React__default.createElement(Form.Item, {
              name: "option_label_" + index
            }, /*#__PURE__*/React__default.createElement(Input, {
              onChange: function onChange(e) {
                var _this4$setState4;

                var options = _this4.state[ItemProperties.OPTIONS];
                options.splice(index, 1, {
                  label: e.target.value,
                  value: item.value
                });

                _this4.setState((_this4$setState4 = {}, _this4$setState4[ItemProperties.OPTIONS] = options, _this4$setState4));
              }
            }))), /*#__PURE__*/React__default.createElement(Col, null, /*#__PURE__*/React__default.createElement(Form.Item, {
              name: "option_value_" + index
            }, /*#__PURE__*/React__default.createElement(Input, {
              onChange: function onChange(e) {
                var _this4$setState5;

                var options = _this4.state[ItemProperties.OPTIONS];
                options.splice(index, 1, {
                  label: item.label,
                  value: e.target.value
                });

                _this4.setState((_this4$setState5 = {}, _this4$setState5[ItemProperties.OPTIONS] = options, _this4$setState5));
              }
            })))));
          }
        })));

      default:
        return undefined;
    }
  };

  _proto.renderProperties = function renderProperties(properties) {
    var _this5 = this;

    return properties.map(function (property, index) {
      return _this5.getProperty(property, index);
    });
  };

  _proto.render = function render() {
    var _this6 = this;

    var _this$props = this.props,
        name = _this$props.name,
        isEditting = _this$props.isEditting,
        attr = _objectWithoutPropertiesLoose(_this$props, _excluded$2);

    return /*#__PURE__*/React__default.createElement(Form, _extends({
      ref: function ref(form) {
        return _this6.form = form;
      },
      name: name,
      style: {
        pointerEvents: 'none'
      },
      onValuesChange: this.onValuesChange,
      layout: "horizontal"
    }, attr, {
      colon: false,
      initialValues: this.getInitialValues()
    }), /*#__PURE__*/React__default.createElement(Form.Item, {
      label: !this.state.label ? ' ' : this.state.label,
      required: this.state.required,
      tooltip: this.state.description,
      rules: ['email'].includes(this.state[ItemProperties.SUB_TYPE]) && [{
        type: this.state[ItemProperties.SUB_TYPE]
      }]
    }, this.renderItem()), /*#__PURE__*/React__default.createElement("div", {
      className: styles$1.transition_height,
      style: {
        display: isEditting ? 'block' : 'none',
        cursor: 'auto',
        pointerEvents: 'auto'
      }
    }, /*#__PURE__*/React__default.createElement(Divider, {
      style: {
        marginTop: '0px'
      }
    }), this.renderProperties(this.properties)));
  };

  return AutoComplete;
}(React__default.Component);

var AutoComplete$1 = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(AutoComplete, _BaseComponent);

  function AutoComplete(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME, ItemProperties.OPTIONS];
    return _BaseComponent.call(this, props, 'Autocomplete', ItemTypes.AUTOCOMPLETE, properties) || this;
  }

  var _proto = AutoComplete.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(AutoComplete$2, {
      placeholder: this.state.placeholder,
      style: {
        pointerEvents: 'auto'
      },
      options: this.state[ItemProperties.OPTIONS].map(function (option) {
        return {
          label: option.label,
          value: option.value
        };
      })
    });
  };

  return AutoComplete;
}(AutoComplete);

var Select = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(Select, _BaseComponent);

  function Select(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME, ItemProperties.OPTIONS];
    return _BaseComponent.call(this, props, 'Select', ItemTypes.SELECT, properties) || this;
  }

  var _proto = Select.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(Select$1, {
      style: {
        pointerEvents: 'auto'
      },
      placeholder: this.state.placeholder,
      options: this.state[ItemProperties.OPTIONS].map(function (option) {
        return {
          label: option.label,
          value: option.value
        };
      })
    });
  };

  return Select;
}(AutoComplete);

var FormFiller = /*#__PURE__*/function (_Component) {
  _inheritsLoose(FormFiller, _Component);

  function FormFiller() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = FormFiller.prototype;

  _proto.renderItem = function renderItem(item) {
    switch (item.type) {
      case ItemTypes.AUTOCOMPLETE:
        return /*#__PURE__*/React__default.createElement(AutoComplete$2, {
          placeholder: item.placeholder,
          options: item.values.map(function (v) {
            return {
              label: v.label,
              value: v.value
            };
          })
        });

      case ItemTypes.CHECK_BOX_GROUP:
        return !item.toggle ? /*#__PURE__*/React__default.createElement(Checkbox.Group, {
          options: item.values.map(function (v) {
            return {
              label: v.label,
              value: v.value
            };
          })
        }) : item.values.map(function (item) {
          return /*#__PURE__*/React__default.createElement(Switch, {
            style: {
              marginRight: 16
            },
            checkedChildren: item.label,
            unCheckedChildren: item.label
          });
        });

      case ItemTypes.DATE:
        return /*#__PURE__*/React__default.createElement(DatePicker, {
          placeholder: item.placeholder
        });

      case ItemTypes.HEADER:
        {
          var Element = item.subtype;
          return /*#__PURE__*/React__default.createElement(Element, null, item.content);
        }

      case ItemTypes.NUMBER:
        {
          return /*#__PURE__*/React__default.createElement(InputNumber, null);
        }

      case ItemTypes.PARAGRAPH:
        {
          var _Element = item.subtype;
          return /*#__PURE__*/React__default.createElement(_Element, null, item.content);
        }

      case ItemTypes.RADIO_GROUP:
        return /*#__PURE__*/React__default.createElement(Radio.Group, {
          options: item.values.map(function (v) {
            return {
              label: v.label,
              value: v.value
            };
          })
        });

      case ItemTypes.SELECT:
        return /*#__PURE__*/React__default.createElement(Select$1, {
          placeholder: item.placeholder,
          options: item.values.map(function (v) {
            return {
              label: v.label,
              value: v.value
            };
          })
        });

      case ItemTypes.TEXT:
        return item.subtype !== 'password' ? /*#__PURE__*/React__default.createElement(Input, {
          type: ['tel', 'color', 'email'].includes(item.subtype) ? item.subtype : '',
          placeholder: item.placeholder
        }) : /*#__PURE__*/React__default.createElement(Input.Password, {
          placeholder: item.placeholder
        });

      case ItemTypes.TEXT_AREA:
        return /*#__PURE__*/React__default.createElement(Input.TextArea, {
          placeholder: item.placeholder
        });
    }
  };

  _proto.onFinish = function onFinish(values) {
    if (this.props.onFinish) this.props.onFinish(values);
  };

  _proto.onFinishFailed = function onFinishFailed(errorInfo) {
    if (this.props.onFinishFailed) this.props.onFinishFailed(errorInfo);
  };

  _proto.render = function render() {
    var _this = this;

    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        margin: 48,
        justifyContent: 'center'
      }
    }, /*#__PURE__*/React__default.createElement(Card, {
      style: {
        width: '50%',
        minWidth: 700,
        overflowY: 'auto'
      }
    }, /*#__PURE__*/React__default.createElement(Form, {
      ref: function ref(form) {
        return _this.formFiller = form;
      },
      onFinish: this.onFinish.bind(this),
      onFinishFailed: this.onFinishFailed.bind(this),
      colon: false,
      layout: "vertical"
    }, this.props.data.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(Form.Item, {
        style: _extends({}, item.type === ItemTypes.HEADER && {
          marginBottom: 0
        }),
        key: index,
        name: item.name,
        label: !item.label ? '' : item.label,
        required: item.required,
        tooltip: item.description,
        rules: [{
          required: item.required
        }].concat(['email'].includes(item.subtype) ? [{
          type: item.subtype
        }] : [])
      }, _this.renderItem(item));
    })), /*#__PURE__*/React__default.createElement(Button, {
      size: "small",
      type: "primary",
      onClick: function onClick() {
        _this.formFiller.submit();
      }
    }, "Submit")));
  };

  return FormFiller;
}(Component);

var Date$1 = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(Date, _BaseComponent);

  function Date(props) {
    var _this;

    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME];
    _this = _BaseComponent.call(this, props, 'Date', ItemTypes.DATE, properties) || this;
    _this.state.options = [];
    return _this;
  }

  var _proto = Date.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(DatePicker, {
      placeholder: this.state.placeholder,
      style: {
        width: '100%',
        pointerEvents: 'auto'
      }
    });
  };

  return Date;
}(AutoComplete);

var CheckBoxGroup = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(CheckBoxGroup, _BaseComponent);

  function CheckBoxGroup(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.TOGGLE, ItemProperties.NAME, ItemProperties.OPTIONS];
    return _BaseComponent.call(this, props, 'CheckBox Groups', ItemTypes.CHECK_BOX_GROUP, properties) || this;
  }

  var _proto = CheckBoxGroup.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(Checkbox.Group, {
      style: {
        pointerEvents: 'auto'
      },
      options: this.state[ItemProperties.OPTIONS].map(function (option) {
        return {
          label: option.label,
          value: option.value
        };
      })
    });
  };

  return CheckBoxGroup;
}(AutoComplete);

var RadioGroup = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(RadioGroup, _BaseComponent);

  function RadioGroup(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.NAME, ItemProperties.OPTIONS];
    return _BaseComponent.call(this, props, 'Radio Group', ItemTypes.RADIO_GROUP, properties) || this;
  }

  var _proto = RadioGroup.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(Radio.Group, {
      style: {
        pointerEvents: 'auto'
      },
      options: this.state[ItemProperties.OPTIONS].map(function (option) {
        return {
          label: option.label,
          value: option.value
        };
      })
    });
  };

  return RadioGroup;
}(AutoComplete);

var TextField = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(TextField, _BaseComponent);

  function TextField(props) {
    var _extends2;

    var _this;

    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME, ItemProperties.SUB_TYPE];
    _this = _BaseComponent.call(this, props, 'Text Field', ItemTypes.TEXT, properties) || this;
    _this.OPTIONS = ['text', 'password', 'email', 'color', 'tel'];
    _this.state = _extends({}, _this.state, (_extends2 = {}, _extends2[ItemProperties.SUB_TYPE] = _this.props.initialValues[ItemProperties.SUB_TYPE] ? _this.props.initialValues[ItemProperties.SUB_TYPE] : _this.OPTIONS[0], _extends2));

    _this.startUpValuesChange();

    return _this;
  }

  var _proto = TextField.prototype;

  _proto.getValueChangeProps = function getValueChangeProps(allValues) {
    var _extends3;

    var props = _BaseComponent.prototype.getValueChangeProps.call(this, allValues);

    return _extends({}, props, (_extends3 = {}, _extends3[ItemProperties.SUB_TYPE] = allValues[ItemProperties.SUB_TYPE], _extends3));
  };

  _proto.getProperty = function getProperty(property, index) {
    var _this2 = this;

    switch (property) {
      case ItemProperties.SUB_TYPE:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.SUB_TYPE,
          label: "Type"
        }, /*#__PURE__*/React__default.createElement(Select$1, {
          options: this.OPTIONS.map(function (item) {
            return {
              label: item,
              value: item
            };
          }),
          onChange: function onChange(v) {
            var _this2$setState;

            return _this2.setState((_this2$setState = {}, _this2$setState[ItemProperties.SUB_TYPE] = v, _this2$setState));
          }
        }));

      default:
        return _BaseComponent.prototype.getProperty.call(this, property, index);
    }
  };

  _proto.renderItem = function renderItem() {
    return this.state[ItemProperties.SUB_TYPE] !== 'password' ? /*#__PURE__*/React__default.createElement(Input, {
      type: ['tel', 'color', 'email'].includes(this.state[ItemProperties.SUB_TYPE]) ? this.state[ItemProperties.SUB_TYPE] : '',
      placeholder: this.state.placeholder,
      style: {
        pointerEvents: 'auto'
      }
    }) : /*#__PURE__*/React__default.createElement(Input.Password, {
      placeholder: this.state.placeholder,
      style: {
        pointerEvents: 'auto'
      }
    });
  };

  return TextField;
}(AutoComplete);

var TextArea = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(TextArea, _BaseComponent);

  function TextArea(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME];
    return _BaseComponent.call(this, props, 'Text Area', ItemTypes.TEXT_AREA, properties) || this;
  }

  var _proto = TextArea.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(Input.TextArea, {
      placeholder: this.state.placeholder,
      style: {
        pointerEvents: 'auto'
      }
    });
  };

  return TextArea;
}(AutoComplete);

var Number$1 = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(Number, _BaseComponent);

  function Number(props) {
    var properties = [ItemProperties.REQUIRED, ItemProperties.LABEL, ItemProperties.DESCRIPTION, ItemProperties.PLACEHOLDER, ItemProperties.NAME];
    return _BaseComponent.call(this, props, 'Number', ItemTypes.NUMBER, properties) || this;
  }

  var _proto = Number.prototype;

  _proto.renderItem = function renderItem() {
    return /*#__PURE__*/React__default.createElement(InputNumber, {
      style: {
        width: '100%',
        pointerEvents: 'auto'
      },
      placeholder: this.state.placeholder
    });
  };

  return Number;
}(AutoComplete);

var Header = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(Header, _BaseComponent);

  function Header(props) {
    var _extends2;

    var _this;

    var properties = [ItemProperties.SUB_TYPE, ItemProperties.CONTENT];
    _this = _BaseComponent.call(this, props, '', ItemTypes.HEADER, properties) || this;
    _this.options = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
    _this.state = _extends({}, _this.state, (_extends2 = {}, _extends2[ItemProperties.SUB_TYPE] = _this.props.initialValues[ItemProperties.SUB_TYPE] ? _this.props.initialValues[ItemProperties.SUB_TYPE] : _this.options[0], _extends2[ItemProperties.CONTENT] = _this.props.initialValues[ItemProperties.CONTENT] ? _this.props.initialValues[ItemProperties.CONTENT] : 'header', _extends2));

    _this.startUpValuesChange();

    return _this;
  }

  var _proto = Header.prototype;

  _proto.getValueChangeProps = function getValueChangeProps(allValues) {
    var _extends3;

    var props = _BaseComponent.prototype.getValueChangeProps.call(this, allValues);

    return _extends({}, props, (_extends3 = {}, _extends3[ItemProperties.SUB_TYPE] = allValues[ItemProperties.SUB_TYPE], _extends3[ItemProperties.CONTENT] = allValues[ItemProperties.CONTENT], _extends3));
  };

  _proto.getProperty = function getProperty(property, index) {
    var _this2 = this;

    switch (property) {
      case ItemProperties.CONTENT:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.CONTENT,
          label: "Content"
        }, /*#__PURE__*/React__default.createElement(Input, {
          onChange: function onChange(e) {
            var _this2$setState;

            _this2.setState((_this2$setState = {}, _this2$setState[ItemProperties.CONTENT] = e.target.value, _this2$setState));
          }
        }));

      case ItemProperties.SUB_TYPE:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.SUB_TYPE,
          label: "Type"
        }, /*#__PURE__*/React__default.createElement(Select$1, {
          options: this.options.map(function (item) {
            return {
              label: item,
              value: item
            };
          }),
          onChange: function onChange(value) {
            var _this2$setState2;

            _this2.setState((_this2$setState2 = {}, _this2$setState2[ItemProperties.SUB_TYPE] = value, _this2$setState2));
          }
        }));

      default:
        return _BaseComponent.prototype.getProperty.call(this, property);
    }
  };

  _proto.renderItem = function renderItem() {
    var Element = this.state[ItemProperties.SUB_TYPE];
    return /*#__PURE__*/React__default.createElement(Element, null, this.state[ItemProperties.CONTENT]);
  };

  return Header;
}(AutoComplete);

var Paragraph = /*#__PURE__*/function (_BaseComponent) {
  _inheritsLoose(Paragraph, _BaseComponent);

  function Paragraph(props) {
    var _extends2;

    var _this;

    var properties = [ItemProperties.SUB_TYPE, ItemProperties.CONTENT];
    _this = _BaseComponent.call(this, props, '', ItemTypes.PARAGRAPH, properties) || this;
    _this.options = ['p', 'address', 'blockquote', 'canvas', 'output'];
    _this.state = _extends({}, _this.state, (_extends2 = {}, _extends2[ItemProperties.SUB_TYPE] = _this.props.initialValues[ItemProperties.SUB_TYPE] ? _this.props.initialValues[ItemProperties.SUB_TYPE] : _this.options[0], _extends2[ItemProperties.CONTENT] = _this.props.initialValues[ItemProperties.CONTENT] ? _this.props.initialValues[ItemProperties.CONTENT] : 'paragraph', _extends2));

    _this.startUpValuesChange();

    return _this;
  }

  var _proto = Paragraph.prototype;

  _proto.getValueChangeProps = function getValueChangeProps(allValues) {
    var _extends3;

    var props = _BaseComponent.prototype.getValueChangeProps.call(this, allValues);

    return _extends({}, props, (_extends3 = {}, _extends3[ItemProperties.SUB_TYPE] = allValues[ItemProperties.SUB_TYPE], _extends3[ItemProperties.CONTENT] = allValues[ItemProperties.CONTENT], _extends3));
  };

  _proto.getProperty = function getProperty(property, index) {
    var _this2 = this;

    switch (property) {
      case ItemProperties.CONTENT:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.CONTENT,
          label: "Content"
        }, /*#__PURE__*/React__default.createElement(Input.TextArea, {
          onChange: function onChange(e) {
            var _this2$setState;

            _this2.setState((_this2$setState = {}, _this2$setState[ItemProperties.CONTENT] = e.target.value, _this2$setState));
          }
        }));

      case ItemProperties.SUB_TYPE:
        return /*#__PURE__*/React__default.createElement(Form.Item, {
          key: index,
          name: ItemProperties.SUB_TYPE,
          label: "Type"
        }, /*#__PURE__*/React__default.createElement(Select$1, {
          options: this.options.map(function (item) {
            return {
              label: item,
              value: item
            };
          }),
          onChange: function onChange(value) {
            var _this2$setState2;

            _this2.setState((_this2$setState2 = {}, _this2$setState2[ItemProperties.SUB_TYPE] = value, _this2$setState2));
          }
        }));

      default:
        return _BaseComponent.prototype.getProperty.call(this, property);
    }
  };

  _proto.renderItem = function renderItem() {
    var Element = this.state[ItemProperties.SUB_TYPE];
    return /*#__PURE__*/React__default.createElement(Element, null, this.state[ItemProperties.CONTENT]);
  };

  return Paragraph;
}(AutoComplete);

var DraggableList = /*#__PURE__*/function (_Component) {
  _inheritsLoose(DraggableList, _Component);

  function DraggableList(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.DRAGGABLE_ITEM_ID = 'draggable_985643215_index_';
    _this.space = 36;
    _this.mouseMove = _this.mouseMove.bind(_assertThisInitialized(_this));
    _this.mouseUp = _this.mouseUp.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = DraggableList.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.initElements();
  };

  _proto.initElements = function initElements() {
    var _this2 = this;

    var _loop = function _loop(index) {
      var element = _this2.container.children[index];
      element.style.transition = 'margin .125s';
      element.style.userSelect = 'none';

      element.onmousedown = function (e) {
        if (!e.target.id.includes(_this2.DRAGGABLE_ITEM_ID)) return;
        _this2.isDragged = true;
        _this2.selectedElement = element;
        _this2.selectedIndex = index;
        element.style.opacity = 0.5;
        element.style.zIndex = 1;
        element.style.border = '1px solid red';
        _this2.startX = e.clientX;
        _this2.startY = e.clientY;
        _this2.selectedElementWidth = element.style.width;
        _this2.selectedElementOffsetLeft = element.offsetLeft;
        _this2.selectedElementOffsetTop = element.offsetTop - _this2.getScrollTop();
        element.style.top = element.offsetTop + 'px';
        element.style.left = element.offsetLeft + 'px';
        element.style.width = element.offsetWidth + 'px';
        element.style.position = 'absolute';

        _this2.mouseMove(e);

        addEventListener('mousemove', _this2.mouseMove);
        addEventListener('mouseup', _this2.mouseUp);
      };
    };

    for (var index = 0; index < this.container.children.length; index++) {
      _loop(index);
    }
  };

  _proto.performMouseMove = function performMouseMove(e, item) {
    this.selectedElement = null;
    this.selectedIndex = -1;
    this.mouseMove(e);
  };

  _proto.performMouseUp = function performMouseUp(e, item) {
    this.mouseUp(e, item);
  };

  _proto.removeOnMouseDowns = function removeOnMouseDowns() {
    for (var _iterator = _createForOfIteratorHelperLoose(this.container.children), _step; !(_step = _iterator()).done;) {
      var element = _step.value;
      element.onmousedown = null;
    }
  };

  _proto.mouseUp = function mouseUp(e, item) {
    if (this.selectedElement) {
      this.selectedElement.style.opacity = 1;
      this.selectedElement.style.position = 'unset';
      this.selectedElement.style.top = 'unset';
      this.selectedElement.style.left = 'unset';
      this.selectedElement.style.border = 'unset';
      this.selectedElement.style.zIndex = 0;
      this.selectedElement.style.width = this.selectedElementWidth;
      this.dropElement(this.selectedIndex, this.droppedIndex);
    }

    if (this.lastAnimatedItem) {
      this.lastAnimatedItem.style.margin = this.lastAnimatedItemMargin;
      this.lastAnimatedItem.style.border = '0px solid gray';
    }

    if (item) {
      this.props.addItem(item, this.droppedIndex ? this.droppedIndex : 0);
    }

    this.cancelScrollTimer();
    removeEventListener('mousemove', this.mouseMove);
    removeEventListener('mouseup', this.mouseUp);
  };

  _proto.setScrollTimer = function setScrollTimer(e) {
    var _this3 = this;

    this.scrollTimer = setTimeout(function () {
      if (_this3.isEndOfScroll()) {
        _this3.cancelScrollTimer();

        return;
      }

      _this3.checkScroll(e);

      _this3.checkPositionAndRearrange(e);

      _this3.setScrollTimer(e);
    }, 200);
  };

  _proto.cancelScrollTimer = function cancelScrollTimer() {
    if (this.scrollTimer) clearTimeout(this.scrollTimer);
    this.scrollTimer = null;
  };

  _proto.checkScroll = function checkScroll(e) {
    var offset = 100;

    if (this.main.offsetHeight - offset < e.clientY) {
      scrollY = 40;
    } else if (e.clientY < offset) {
      scrollY = -40;
    } else {
      this.cancelScrollTimer();
      return;
    }

    if (!this.scrollTimer) {
      this.setScrollTimer(e);
    }

    this.main.scrollBy({
      top: scrollY,
      behavior: 'smooth'
    });
  };

  _proto.mouseMove = function mouseMove(e) {
    if (this.selectedElement) {
      var deltaX = e.clientX - this.startX;
      var deltaY = e.clientY - this.startY;
      this.selectedElement.style.top = this.selectedElementOffsetTop + deltaY + 'px';
      this.selectedElement.style.left = this.selectedElementOffsetLeft + deltaX + 'px';
    }

    this.checkScroll(e);
    this.checkPositionAndRearrange(e);
  };

  _proto.getScrollTop = function getScrollTop() {
    return this.main.scrollTop;
  };

  _proto.isEndOfScroll = function isEndOfScroll() {
    return this.main.offsetHeight + this.main.scrollTop >= this.main.scrollHeight;
  };

  _proto.checkPositionAndRearrange = function checkPositionAndRearrange(e) {
    var _this4 = this;

    var children = [].slice.call(this.container.children);

    if (this.lastAnimatedItem) {
      this.lastAnimatedItem.style.margin = this.lastAnimatedItemMargin;
    }

    children = children.map(function (element, index) {
      return {
        element: element,
        index: index
      };
    }).filter(function (_, index) {
      return index !== _this4.selectedIndex;
    });
    children.forEach(function (_ref, fakeIndex) {
      var element = _ref.element;
      var nextElement = fakeIndex === children.length - 1 ? null : children[fakeIndex + 1].element;

      if (fakeIndex === 0 && e.clientY + _this4.getScrollTop() < element.offsetTop + element.offsetHeight / 2) {
        _this4.lastAnimatedItemMargin = element.style.margin;
        element.style.marginTop = _this4.space + 'px';
        _this4.lastAnimatedItem = element;
        _this4.droppedIndex = 0;
      } else if (fakeIndex === children.length - 1 && e.clientY + _this4.getScrollTop() > element.offsetTop + element.offsetHeight / 2) {
        _this4.lastAnimatedItemMargin = element.style.margin;
        element.style.marginBottom = _this4.space + 'px';
        _this4.lastAnimatedItem = element;
        _this4.droppedIndex = fakeIndex + 1;
      } else if (e.clientY + _this4.getScrollTop() > element.offsetTop + element.offsetHeight / 2 && e.clientY + _this4.getScrollTop() < nextElement.offsetTop + nextElement.offsetHeight / 2) {
        _this4.lastAnimatedItemMargin = nextElement.style.margin;
        nextElement.style.marginTop = _this4.space + 'px';
        _this4.droppedIndex = fakeIndex + 1;
        _this4.lastAnimatedItem = nextElement;
      }
    });
  };

  _proto.dropElement = function dropElement(draggedIndex, droppedIndex) {
    var _this5 = this;

    this.props.onChange(draggedIndex, droppedIndex).then(function () {
      _this5.scrollToIndex(droppedIndex);
    });
  };

  _proto.scrollToLastIndex = function scrollToLastIndex() {
    this.container.children[this.container.children.length - 1].scrollIntoView();
  };

  _proto.scrollToIndex = function scrollToIndex(i) {
    for (var index = 0; index < this.container.children.length; index++) {
      if (index === i) this.container.children[index].scrollIntoView();
    }
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.removeOnMouseDowns();
    this.initElements();
  };

  _proto.render = function render() {
    var _this6 = this;

    return /*#__PURE__*/React__default.createElement("div", {
      ref: function ref(main) {
        return _this6.main = main;
      },
      style: {
        height: '100%',
        overflowY: 'auto',
        overflowX: 'hidden'
      }
    }, /*#__PURE__*/React__default.createElement("div", {
      ref: function ref(container) {
        return _this6.container = container;
      },
      style: {
        display: 'flex',
        flexFlow: 'column',
        alignItems: 'center',
        justifyContent: 'center'
      }
    }, this.props.dataSource && this.props.dataSource.map(function (item, index) {
      return _this6.props.renderItem(item, index, _this6.DRAGGABLE_ITEM_ID + index);
    })));
  };

  return DraggableList;
}(Component);

var DraggableList$1 = /*#__PURE__*/function (_Component) {
  _inheritsLoose(DraggableList, _Component);

  function DraggableList(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.mouseMoved = false;
    _this.mouseMove = _this.mouseMove.bind(_assertThisInitialized(_this));
    _this.mouseUp = _this.mouseUp.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = DraggableList.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.initElements();
  };

  _proto.initElements = function initElements() {
    var _this2 = this;

    var _loop = function _loop(index) {
      var element = _this2.container.children[index];
      element.style.transition = 'margin .125s';
      element.style.userSelect = 'none';

      element.onmousedown = function (e) {
        _this2.isDragged = true;

        var el = _this2.container.appendChild(element.cloneNode(true));

        _this2.draggedElement = el;
        _this2.selectedElement = element;
        _this2.selectedIndex = index;
        _this2.selectedItem = _this2.props.dataSource[index];
        _this2.space = 36;
        element.style.opacity = 0.5;
        el.style.zIndex = 1;
        _this2.startX = e.clientX;
        _this2.startY = e.clientY;
        _this2.selectedElementWidth = element.style.width;
        _this2.selectedElementOffsetLeft = element.offsetLeft;
        _this2.selectedElementOffsetTop = element.offsetTop;
        el.style.top = element.offsetTop + 'px';
        el.style.left = element.offsetLeft + 'px';
        el.style.width = element.offsetWidth + 'px';
        el.style.position = 'absolute';

        _this2.props.mouseDown(e);

        addEventListener('mousemove', _this2.mouseMove);
        addEventListener('mouseup', _this2.mouseUp);
      };
    };

    for (var index = 0; index < this.container.children.length; index++) {
      _loop(index);
    }
  };

  _proto.removeOnMouseDowns = function removeOnMouseDowns() {
    for (var _iterator = _createForOfIteratorHelperLoose(this.container.children), _step; !(_step = _iterator()).done;) {
      var element = _step.value;
      element.onmousedown = null;
    }
  };

  _proto.mouseUp = function mouseUp(e) {
    this.selectedElement.style.opacity = 1;
    this.draggedElement.style.position = 'unset';
    this.draggedElement.style.top = 'unset';
    this.draggedElement.style.left = 'unset';
    this.draggedElement.style.border = 'unset';
    this.draggedElement.style.zIndex = 0;
    this.draggedElement.style.width = this.selectedElementWidth;

    if (this.lastAnimatedItem) {
      this.lastAnimatedItem.style.margin = this.lastAnimatedItemMargin;
      this.lastAnimatedItem.style.border = '0px solid gray';
    }

    this.container.removeChild(this.draggedElement);
    removeEventListener('mousemove', this.mouseMove);
    removeEventListener('mouseup', this.mouseUp);
    if (!this.mouseMoved) this.props.onItemClick(this.selectedItem);else this.props.mouseUp(e, this.selectedItem);
    this.mouseMoved = false;
  };

  _proto.mouseMove = function mouseMove(e) {
    this.mouseMoved = true;
    this.props.mouseMove(e, this.selectedItem);
    var deltaX = e.clientX - this.startX;
    var deltaY = e.clientY - this.startY;
    this.draggedElement.style.top = this.selectedElementOffsetTop + deltaY + 'px';
    this.draggedElement.style.left = this.selectedElementOffsetLeft + deltaX + 'px';
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.removeOnMouseDowns();
    this.initElements();
  };

  _proto.render = function render() {
    var _this3 = this;

    return /*#__PURE__*/React__default.createElement("div", {
      ref: function ref(main) {
        return _this3.main = main;
      }
    }, /*#__PURE__*/React__default.createElement("div", {
      ref: function ref(container) {
        return _this3.container = container;
      },
      style: {
        display: 'flex',
        flexFlow: 'column',
        alignItems: 'center',
        justifyContent: 'center'
      }
    }, this.props.dataSource && this.props.dataSource.map(function (item, index) {
      return _this3.props.renderItem(item, index);
    })));
  };

  return DraggableList;
}(Component);

var FormBuilder = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(FormBuilder, _React$Component);

  function FormBuilder(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      data: [],
      showFormFiller: false
    };
    _this.sequence = 0;
    _this.buttons = [{
      title: 'Autocomplete',
      key: ItemTypes.AUTOCOMPLETE
    }, {
      title: 'Checkbox Group',
      key: ItemTypes.CHECK_BOX_GROUP
    }, {
      title: 'Date Field',
      key: ItemTypes.DATE
    }, {
      title: 'Header',
      key: ItemTypes.HEADER
    }, {
      title: 'Number',
      key: ItemTypes.NUMBER
    }, {
      title: 'Paragraph',
      key: ItemTypes.PARAGRAPH
    }, {
      title: 'Radio Group',
      key: ItemTypes.RADIO_GROUP
    }, {
      title: 'Select',
      key: ItemTypes.SELECT
    }, {
      title: 'Text Field',
      key: ItemTypes.TEXT
    }, {
      title: 'Text Area',
      key: ItemTypes.TEXT_AREA
    }];

    _this.handleClick = function (item) {
      var data = _this.state.data;
      _this.sequence++;
      data.push(_extends({}, item, {
        key: _this.sequence
      }));

      _this.setState({
        data: data
      }, function () {
        _this.formItemList.scrollToLastIndex();
      });
    };

    _this.setLayout = function (input) {
      return input;
    };

    _this.renderItem = function (item, index) {
      var Element;

      switch (item.type) {
        case ItemTypes.AUTOCOMPLETE:
          Element = AutoComplete$1;
          break;

        case ItemTypes.BUTTON:
          Element = Button;
          break;

        case ItemTypes.CHECK_BOX_GROUP:
          Element = CheckBoxGroup;
          break;

        case ItemTypes.DATE:
          Element = Date$1;
          break;

        case ItemTypes.HEADER:
          Element = Header;
          break;

        case ItemTypes.NUMBER:
          Element = Number$1;
          break;

        case ItemTypes.PARAGRAPH:
          Element = Paragraph;
          break;

        case ItemTypes.RADIO_GROUP:
          Element = RadioGroup;
          break;

        case ItemTypes.SELECT:
          Element = Select;
          break;

        case ItemTypes.TEXT:
          Element = TextField;
          break;

        case ItemTypes.TEXT_AREA:
          Element = TextArea;
          break;
      }

      return _this.setLayout( /*#__PURE__*/React__default.createElement(Element, _extends({}, _this.formItemLayout, {
        initialValues: item,
        key: index,
        name: "form-" + index,
        onValuesChange: function onValuesChange(allValues) {
          _this.onValuesChange(allValues, index);
        },
        isEditting: item.isEditting,
        edit: function edit(isEditting) {
          _this.editItem(isEditting, index);
        }
      })));
    };

    _this.formItemLayout = {
      labelCol: {
        span: 7
      },
      wrapperCol: {
        span: 10
      }
    };
    _this.formRef = React__default.createRef();
    return _this;
  }

  var _proto = FormBuilder.prototype;

  _proto.splice = function splice(array, index, item) {
    return [].concat(array.slice(0, index), [item], array.slice(index, array.length));
  };

  _proto.addItemToIndex = function addItemToIndex(item, index) {
    var data = [].concat(this.state.data);
    this.sequence++;
    data = this.splice(data, index, _extends({}, item, {
      isEditting: false,
      key: this.sequence
    }));
    this.setState({
      data: data
    });
  };

  _proto.editItem = function editItem(isEditting, index) {
    var data = this.state.data;

    var item = _extends({}, data[index], {
      isEditting: isEditting
    });

    data.splice(index, 1, item);
    this.setState({
      data: data
    });
  };

  _proto.onValuesChange = function onValuesChange(allValues, index) {
    var data = this.state.data;

    var item = _extends({}, data[index], allValues);

    data.splice(index, 1, item);
    this.setState({
      data: data
    });
  };

  _proto.getJson = function getJson() {
    return this.state.data.map(function (item) {
      delete item.isEditting;
      return item;
    });
  };

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        justifyContent: 'center',
        height: '100%',
        overflow: 'hidden',
        position: 'relative'
      }
    }, /*#__PURE__*/React__default.createElement(Button, {
      style: {
        position: 'fixed',
        right: 48,
        bottom: 0,
        margin: 24,
        zIndex: '1',
        width: 60
      },
      size: "small",
      type: "primary",
      onClick: function onClick() {
        _this2.setState({
          showFormFiller: !_this2.state.showFormFiller
        });
      }
    }, this.state.showFormFiller ? 'Edit' : 'Render'), !this.state.showFormFiller ? /*#__PURE__*/React__default.createElement("div", {
      className: styles.test,
      style: {
        width: '100%',
        display: 'flex',
        flexFlow: 'row',
        padding: '0.5em',
        textAlign: 'left'
      }
    }, /*#__PURE__*/React__default.createElement(DraggableList$1, {
      dataSource: this.buttons,
      mouseDown: function mouseDown(e) {},
      mouseMove: function mouseMove(e, item) {
        _this2.formItemList.performMouseMove(e, item);
      },
      mouseUp: function mouseUp(e, item) {
        _this2.formItemList.performMouseUp(e, item);
      },
      onItemClick: function onItemClick(item) {
        _this2.handleClick({
          type: item.key
        });
      },
      renderItem: function renderItem(item, index) {
        return /*#__PURE__*/React__default.createElement(Button, {
          key: index,
          style: {
            textAlign: 'left',
            width: 200,
            border: 'none'
          }
        }, item.title);
      }
    }), /*#__PURE__*/React__default.createElement(List, {
      itemLayout: "vertical",
      style: {
        border: '1px solid #eee'
      },
      dataSource: this.buttons,
      renderItem: function renderItem(item, index) {
        return /*#__PURE__*/React__default.createElement(List.Item, {
          style: {
            padding: 0
          },
          key: index
        });
      }
    }), /*#__PURE__*/React__default.createElement("div", {
      style: {
        width: '100%',
        height: '100%',
        overflow: 'hidden',
        padding: 24,
        border: '1px solid #e7e7e7'
      }
    }, /*#__PURE__*/React__default.createElement(Form.Provider, {
      name: "form_builder"
    }, /*#__PURE__*/React__default.createElement(DraggableList, {
      ref: function ref(list) {
        return _this2.formItemList = list;
      },
      addItem: function addItem(item, droppedIndex) {
        _this2.addItemToIndex({
          type: item.key
        }, droppedIndex);
      },
      onChange: function onChange(fromIndex, toIndex) {
        return new Promise(function (resolve, reject) {
          var data = _this2.state.data;
          var element = data[fromIndex];
          data.splice(fromIndex, 1);
          data.splice(toIndex, 0, element);

          _this2.setState({
            data: data
          }, function () {
            resolve();
          });
        });
      },
      dataSource: this.state.data,
      renderItem: function renderItem(item, index, draggableItemId) {
        return /*#__PURE__*/React__default.createElement("div", {
          key: item.key,
          id: draggableItemId,
          className: styles.item,
          style: {
            backgroundColor: '#f8f8f8',
            margin: 4,
            paddingTop: 24,
            cursor: 'move',
            position: 'relative',
            width: '100%'
          }
        }, /*#__PURE__*/React__default.createElement(Row, {
          className: styles.actions,
          style: {
            cursor: 'unset',
            width: 'fit-content',
            paddingLeft: '10px',
            paddingTop: '2px',
            position: 'absolute'
          }
        }, /*#__PURE__*/React__default.createElement(Tooltip, {
          placement: "top",
          title: "Delete"
        }, /*#__PURE__*/React__default.createElement(Button, {
          icon: /*#__PURE__*/React__default.createElement(CloseOutlined$2, null),
          size: "small",
          type: "link",
          onClick: function onClick() {
            _this2.setState({
              data: _this2.state.data.filter(function (item, i) {
                return i !== index;
              })
            });
          },
          danger: true,
          shape: "circle"
        })), /*#__PURE__*/React__default.createElement(Tooltip, {
          placement: "top",
          title: "Edit"
        }, /*#__PURE__*/React__default.createElement(Button, {
          icon: /*#__PURE__*/React__default.createElement(EditOutlined$2, null),
          size: "small",
          type: "link",
          onClick: function onClick() {
            _this2.editItem(!item.isEditting, index);
          },
          shape: "circle"
        })), /*#__PURE__*/React__default.createElement(Tooltip, {
          placement: "top",
          title: "Duplicate"
        }, /*#__PURE__*/React__default.createElement(Button, {
          icon: /*#__PURE__*/React__default.createElement(CopyOutlined$2, null),
          size: "small",
          type: "link",
          onClick: function onClick() {
            _this2.addItemToIndex(_this2.state.data[index], index + 1);
          },
          shape: "circle"
        }))), _this2.renderItem(item, index));
      }
    })))) : /*#__PURE__*/React__default.createElement(FormFiller, {
      data: this.state.data,
      onFinishFailed: function onFinishFailed(errorInfo) {
        console.log('validate failed');
      },
      onFinish: function onFinish(values) {
        console.log(values);
      }
    }));
  };

  return FormBuilder;
}(React__default.Component);

var index = {
  FormBuilder: FormBuilder,
  FormFiller: FormFiller
};

export default index;
//# sourceMappingURL=index.modern.js.map
